-- ----------------------------------------------------------------------
-- MySQL GRT Application
-- SQL Script
-- ----------------------------------------------------------------------

SET FOREIGN_KEY_CHECKS = 0;

CREATE DATABASE IF NOT EXISTS `hdemo`
  CHARACTER SET utf8;
-- -------------------------------------
-- Tables

DROP TABLE IF EXISTS `hdemo`.`account`;
CREATE TABLE `hdemo`.`account` (
  `id` MEDIUMINT(9) NOT NULL AUTO_INCREMENT,
  `client_id` MEDIUMINT(9) NOT NULL DEFAULT '0',
  `accountNumber` VARCHAR(255) NOT NULL,
  PRIMARY KEY (`id`),
  INDEX `client_id` (`client_id`),
  CONSTRAINT `account_ibfk_1` FOREIGN KEY `account_ibfk_1` (`client_id`)
    REFERENCES `hdemo`.`client` (`id`)
    ON DELETE RESTRICT
    ON UPDATE RESTRICT
)
ENGINE = InnoDB
ROW_FORMAT = Dynamic
CHARACTER SET utf8 COLLATE utf8_general_ci;

DROP TABLE IF EXISTS `hdemo`.`address`;
CREATE TABLE `hdemo`.`address` (
  `id` MEDIUMINT(9) NOT NULL AUTO_INCREMENT,
  `client_id` MEDIUMINT(9) NOT NULL DEFAULT '0',
  `street` VARCHAR(255) NOT NULL,
  `streetNo` VARCHAR(255) NOT NULL,
  `municipality` VARCHAR(255) NOT NULL,
  `zipCode` VARCHAR(255) NOT NULL,
  PRIMARY KEY (`id`),
  INDEX `client_id` (`client_id`),
  CONSTRAINT `address_ibfk_1` FOREIGN KEY `address_ibfk_1` (`client_id`)
    REFERENCES `hdemo`.`client` (`id`)
    ON DELETE RESTRICT
    ON UPDATE RESTRICT
)
ENGINE = InnoDB
ROW_FORMAT = Dynamic
CHARACTER SET utf8 COLLATE utf8_general_ci;

DROP TABLE IF EXISTS `hdemo`.`client`;
CREATE TABLE `hdemo`.`client` (
  `id` MEDIUMINT(9) NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(45) NOT NULL,
  `personId` INT(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
)
ENGINE = InnoDB
ROW_FORMAT = Dynamic
CHARACTER SET utf8 COLLATE utf8_general_ci;



SET FOREIGN_KEY_CHECKS = 1;

-- ----------------------------------------------------------------------
-- EOF

