package net.krecan.demo.bank;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;

@Entity
@Table(name="address")
public class Address {
	@Id @GeneratedValue(strategy=GenerationType.AUTO)
	private Integer id;
	
	@Column
	private String street;
	
	@Column
	private String streetNo;
	
	@Column
	private String municipality;
	
	@Column
	private String zipCode;
	
	public Address() {
		super();
	}

	public Address(String street, String streetNo, String municipality, String zipCode) {
		super();
		this.street = street;
		this.streetNo = streetNo;
		this.municipality = municipality;
		this.zipCode = zipCode;
	}
	
	public String getStreet() {
		return street;
	}


	public String getMunicipality() {
		return municipality;
	}


	public String getStreetNo() {
		return streetNo;
	}


	public String getZipCode() {
		return zipCode;
	}

	@Override
	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result + ((municipality == null) ? 0 : municipality.hashCode());
		result = PRIME * result + ((street == null) ? 0 : street.hashCode());
		result = PRIME * result + ((streetNo == null) ? 0 : streetNo.hashCode());
		result = PRIME * result + ((zipCode == null) ? 0 : zipCode.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final Address other = (Address) obj;
		if (municipality == null) {
			if (other.municipality != null)
				return false;
		} else if (!municipality.equals(other.municipality))
			return false;
		if (street == null) {
			if (other.street != null)
				return false;
		} else if (!street.equals(other.street))
			return false;
		if (streetNo == null) {
			if (other.streetNo != null)
				return false;
		} else if (!streetNo.equals(other.streetNo))
			return false;
		if (zipCode == null) {
			if (other.zipCode != null)
				return false;
		} else if (!zipCode.equals(other.zipCode))
			return false;
		return true;
	}

	/**
	 * Constructs a <code>String</code> with all attributes
	 * in name = value format.
	 *
	 * @return a <code>String</code> representation 
	 * of this object.
	 */
	public String toString()
	{
	    final String TAB = "    ";
	    
	    String retValue = "";
	    
	    retValue = "Address ( "
	        + super.toString() + TAB
	        + "id = " + this.id + TAB
	        + "street = " + this.street + TAB
	        + "streetNo = " + this.streetNo + TAB
	        + "municipality = " + this.municipality + TAB
	        + "zipCode = " + this.zipCode + TAB
	        + " )";
	    
	    return retValue;
	}


}
