package net.krecan.demo.bank.dao;

import java.sql.SQLException;
import java.util.List;

import net.krecan.demo.bank.Client;

import org.hibernate.FetchMode;
import org.hibernate.Hibernate;
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.criterion.Expression;
import org.springframework.orm.hibernate3.HibernateCallback;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

public class ClientDao extends HibernateDaoSupport {

	public Client getClient(final Long personId) {
		return (Client) getHibernateTemplate().execute(new HibernateCallback(){
			public Object doInHibernate(Session session) throws HibernateException, SQLException {
				return (Client) session.createCriteria(Client.class).
					add(Expression.eq("personId", personId)).
					setFetchMode("addresses", FetchMode.JOIN).
					setFetchMode("accounts", FetchMode.JOIN).
					uniqueResult();
			}
		});
	}

	public void saveClient(Client client) {
		getHibernateTemplate().saveOrUpdate(client);
	}

	public void deleteClient(Client client) {
		getHibernateTemplate().delete(client);
	}

	@SuppressWarnings("unchecked")
	public List<Client> getClients(final int fromRow, final int toRow)
	{
		return (List<Client>)getHibernateTemplate().execute(new HibernateCallback(){

			public Object doInHibernate(Session session) throws HibernateException, SQLException {
				 List result = session.createQuery("from Client c order by personId asc").setFirstResult(fromRow).setMaxResults(toRow-fromRow).list();
				 Hibernate.initialize(result);
				 return result;
//				 return session.createQuery("from Client c " +
//				 		"left join fetch c.accounts " +
//				 		"left join fetch c.addresses " +
//				 		"order by personId asc").
//				 		setFirstResult(fromRow).setMaxResults(toRow-fromRow).list();
//				return session.createCriteria(Client.class).
//					setFetchMode("addresses", FetchMode.JOIN).
//					setFetchMode("accounts", FetchMode.JOIN).
//					setFirstResult(fromRow).setMaxResults(toRow-fromRow).
//					addOrder(Order.asc("personId")).
//					list();
			}
			
		});
	}
}
