package net.krecan.demo.bank.dao;

import java.sql.SQLException;

import net.krecan.demo.bank.Account;
import net.krecan.demo.bank.Address;
import net.krecan.demo.bank.Client;

import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.springframework.orm.hibernate3.HibernateCallback;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

public class TestClientDao extends HibernateDaoSupport {
	public void createTestData(final int clients, final int addresses, final int accounts)
	{
		getHibernateTemplate().execute(new HibernateCallback(){
			public Object doInHibernate(Session session) throws HibernateException, SQLException {
				Transaction tx = session.beginTransaction();
				for (int i=0;i<clients;i++)
				{
					Client client = new Client(10000L+i);
					client.setName("client "+i);
					for (int ad=0;ad<addresses;ad++)
					{
						client.addAddress(new Address("Street "+ad, Integer.toString(ad), "Municipality"+client.getPersonId(),  client.getPersonId().toString()));
					}
					for (int ac=0; ac<accounts;ac++)
					{
						client.addAccount(new Account(client.getPersonId().toString()+Integer.toString(ac)));
					}
					session.save(client);
					session.evict(client);
				}
				tx.commit();
				return null;
			}
		});
	}
}
