package net.krecan.demo.bank.dao;

import net.krecan.demo.bank.Account;
import net.krecan.demo.bank.Address;
import net.krecan.demo.bank.Client;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.test.AbstractDependencyInjectionSpringContextTests;


public class ClientDaoTest extends AbstractDependencyInjectionSpringContextTests {

	private static final long CLIENT_ID = 1234L;
	private ClientDao dao;
	private Client client;
	
	private static final Log LOG = LogFactory.getLog(ClientDaoTest.class);
	
	@Override
	protected String[] getConfigLocations() {
		return new String[]{"applicationContext.xml"};
	}

	public void setDao(ClientDao dao) {
		this.dao = dao;
	}
	
	@Override
	protected void onSetUp() throws Exception {
		super.onSetUp();
		client = new Client(CLIENT_ID);
		client.setName("test1");
		dao.saveClient(client);
	}
	
	@Override
	protected void onTearDown() throws Exception {
		super.onTearDown();
		dao.deleteClient(client);
	}
	public void testCreateClient()
	{
		client.addAddress(new Address("Street","20","Municipality","12321"));
		client.addAddress(new Address("Street2","40","Municipality II","12322"));
		
		client.addAccount(new Account("1234-5678"));
		client.addAccount(new Account("1234-5679"));
		
		dao.saveClient(client);
		
		Client client2 = dao.getClient(CLIENT_ID);
		assertEquals(client.getAddresses(), client2.getAddresses());
		assertEquals(client.getAccounts(), client2.getAccounts());
		
		
	}
	

}
