package net.krecan.demo.bank.dao;

import java.util.List;

import net.krecan.demo.bank.Client;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.test.AbstractTransactionalSpringContextTests;

public class PagingTest extends AbstractTransactionalSpringContextTests{

	private static final Log LOG = LogFactory.getLog(PagingTest.class);
	private ClientDao dao;
	
	@Override
	protected String[] getConfigLocations() {
		return new String[]{"applicationContext.xml"};
	}
	
	public void testPaging()
	{
		List<Client> clients = dao.getClients(1000, 1050);
		LOG.debug("Loaded clients: "+clients);
		long clientNum = 11000L;
		assertEquals(50, clients.size());
		for(Client client:clients)
		{
			assertEquals(clientNum++, client.getPersonId().longValue());
			assertEquals(5, client.getAddresses().size());
			assertEquals(10, client.getAccounts().size());
		}
		
	}

	public void setDao(ClientDao dao) {
		this.dao = dao;
	}

}
